import java.io.*;
import java.util.*;

public class Main {
    static class Point {
        long x, y;
    }

    static class PointComporator implements Comparator<Point> {
        public int compare(Point o1, Point o2) {
            return Long.compare(o1.x, o2.x);
        }
    }

    public static void main(String[] args) throws IOException {
        int h = nextInt();
        int w = nextInt();
        long a[][] = new long[h][w];
        for (int i = 0; i < h; i++) {
            for (int j = 0; j < w; j++) {
                a[i][j] = nextInt();
            }
        }
        long s[][] = new long[h + 1][w + 1];
        for (int i = 1; i < h + 1; i++) {
            for (int j = 1; j < w + 1; j++) {
                if (h != 1 && w != 1) s[i][j] = s[i - 1][j] + s[i][j - 1] - s[i - 1][j - 1] + a[i - 1][w - 1];
                else s[i][j] = s[i - 1][j] + s[i][j - 1] - s[i - 1][j - 1] + a[i - 1][w - 1];
            }
        }
        for (int i = 1; i < h + 1; i++) {
            for (int j = 1; j < w + 1; j++) {
                if (!(i == 1 && j == 1)) s[i][j] = s[i][j] + s[1][1];
            }
        }
        long sum = nextLong();
        long x1 = 0;
        long y1 = 0;
        long x2 = 0;
        long y2 = 0;
        for (int i = 1; i < h + 1; i++) {
            for (int j = 1; j < w + 1; j++) {
                for (int k = 1; k < h + 1; k++) {
                    for (int l = 1; l < w + 1; l++) {
                        if (sum == s[k][l] - s[i][j]) {
                            x1 = i;
                            y1 = j;
                            x2 = k;
                            y2 = l;
                        }
                    }
                }
            }
        }
        if (x1 != 0) {
            out.println("YES");
            out.println(h-x2+x1-1+w-y2+y1-1);
            for (int i = 1; i <h+1 ; i++) {
                if(i<x1||i>x2)out.println(1+" "+i);
            }
            for (int i = 1; i <w+1 ; i++) {
                if(i<y1||i>y2)out.println(2+" "+i);
            }
        } else {
            out.println("NO");
            out.close();
            return;
        }

        out.close();

    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}